# 进程管理设计

## 设计需求
调度进程的运行，支持yield、wait、clone等系统调用；管理进程所需的资源（页面、内核堆、页表、文件描述符），并在进程退出时及时释放。

## 调度器

由于时间问题，暂不考虑外存置换相关操作。

调度器需要支持的功能：创建进程、退出进程、yield、wait、调度。

进程调度的经典模型是五状态模型（不考虑外存置换）和七状态模型（考虑外存置换）。为简单起见，在五状态模型上进一步简化：创建进程操作为立即执行（分配空间等操作），可以删去NEW状态；进程退出时只需保留pid和返回值，这部分信息会存储在父进程的信号队列里，因此也没有必要保留。此调度器实现的其实是一个三状态模型（运行、就绪、阻塞）。

在数据结构上，调度器内部维护一个就绪态PCB链表，一个阻塞态PCB链表；每个PCB中维护一个接收到的信号链表。

#### 创建进程

创建新进程时，分配其内存空间、栈空间、一级页表空间；并初始化PCB中的资源链表。

#### 退出进程

退出进程时，释放其占用的文件描述符、内存空间、栈空间，递归释放页表空间。

#### yield

将正在运行的程序上下文保存，将PCB置于就绪队列的最后。

#### wait

将正在运行的程序上下文保存，将PCB置于阻塞队列中。当调度器检测到此PCB收到信号时，会将其重新置入就绪队列。

#### 退出进程

退出进程时，释放其占用的文件描述符、内存空间、栈空间，递归释放页表空间。同时，将pid和exit返回值挂到父进程的信号链表上。
